
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include "encabezados.h"





extern NODO **tabla_hash;
int t_hash;

/* busca el ultimo nodo en una lista */
NODO * ultimo_nodo(NODO * lista) {
  if (lista==NULL) return NULL;
  if (lista->siguiente == NULL) return lista;
  return ultimo_nodo(lista->siguiente);
}



/* buscar un nodo de la lista */
P_NODO buscar_nodo (NODO *lista,char *contenido) {
  NODO *aux=lista;
  while(aux != NULL) {
    if(strcmp(aux->palabra,contenido) == 0) break;//busca que el contenido se encuentre en algun nodo
    aux = aux->siguiente;
  }
  return aux;
}



/* Funcion para insertar un nodo a la lista */
NODO *insertar_nodo (NODO *lista, NODO *nodo,int pos) {
  int p=0;
  P_NODO aux = lista;
  P_NODO ant = NULL;
  if ( pos < 0) return NULL;
  while ( (p < pos) && (aux->siguiente != NULL) )
    {
      p++;
      ant = aux;
      aux = aux->siguiente;
    }
  if (ant!=NULL) ant->siguiente = nodo;
  else lista = nodo;
  nodo->anterior = ant;
  if (aux!=NULL) aux->anterior = nodo;
  nodo->siguiente = aux;
  return lista;
}



/* funcion para eliminar nodo */
NODO * eliminar_nodo (NODO * lista, char * contenido) {
  NODO * ant , * sig;
  NODO * aux = buscar_nodo(lista, contenido);
  if (aux==NULL) return lista; // no se encontro
  ant = aux->anterior;
  sig = aux->siguiente;
  if (ant != NULL) ant->siguiente = sig;
  else lista = sig;
  if (sig != NULL) sig->anterior = ant;
  //liberar memoria ocupada por aux
  free(aux);
  return lista;
}

/* eliminar un nodo segun su posicion */
NODO * eliminar_nodo_pos (NODO * lista, int pos) {
  int p = 0;
  NODO * aux = lista;
  NODO * ant = NULL;
  if (pos < 0) return lista;
  while ( (p<pos) && (aux!=NULL) ){
    p++;
    ant = aux;
    aux = aux->siguiente;
  }
  if (aux == NULL) return lista;
  if (ant!=NULL) ant->siguiente = aux->siguiente;
  else lista = aux->siguiente;
  if (aux->siguiente!=NULL) aux->siguiente->anterior = ant;
  free(aux);
  return lista;
}



/* funcion para crear un nodo */
P_NODO crear_nodo(char *contenido, int frecuencia) {
  NODO *nuevo_nodo;
  if((nuevo_nodo = (NODO *)malloc(sizeof(NODO)))==NULL) {
    printf("\n Error de memoria al crear un nodo ...\n");exit(0);
  }
  strcpy(nuevo_nodo->palabra,contenido);
  nuevo_nodo->frecuencia=frecuencia;
  return nuevo_nodo;
}



/* retorna la cantidad de nodos en la lista, apartir del nodo 'primer' */
int largo_lista( NODO * primer ) {
  if (primer==NULL) return 0;
  return 1 + largo_lista(primer->siguiente);
}



