

#include <stdio.h>
#include <string.h>
#include "encabezados.h"

extern int largo_lista( NODO *);
extern NODO * ultimo_nodo(NODO *);


/* intercambia los valores en los nodos a y b */
void swap_val_nodos(NODO * a, NODO * b) {
  char tmp_pal[MAX_PALABRA];
  int tmp_frec;

  strcpy(tmp_pal,a->palabra);
  strcpy(a->palabra,b->palabra);
  strcpy(b->palabra,tmp_pal);

  tmp_frec = a->frecuencia;
  a->frecuencia = b->frecuencia;
  b->frecuencia = tmp_frec;

}


/* ordena la lista */
NODO * sort_lista(NODO * lista) {
  //compara la lista de atras hacia adelante, dejando los mayores al final.
  NODO * aux, * piv, * tmp, * inicio;
  int largo;
  if (lista==NULL) return NULL;
  largo = largo_lista(lista);
  piv = ultimo_nodo(lista);
  if (piv->anterior == NULL) return lista;
  inicio = lista;
  aux = piv->anterior;
  while (1) {
    if(aux == NULL) break;
    if (nodo_menorque(aux,piv)==0 ) {
      if (inicio==aux) inicio=piv;
      swap_val_nodos(aux,piv);
    }
    if (aux->anterior!=NULL){
      aux = aux->anterior;
    }
    else {
      piv = piv->anterior;
      if (piv==inicio) break;
      aux = piv->anterior;
    }
  }
  return inicio;
}

/* compara los nodos a y b, retorna 1 si a es menor en frecuencia, y mayor (posterior) alfabeticamente */
int nodo_menorque(NODO * a, NODO * b) {
  if (a->frecuencia < b->frecuencia) return 1;
  if (a->frecuencia > b->frecuencia) return 0;
  if (strcmp(a->palabra, b->palabra) > 0) return 1;  //ambas frecuencia son iguales, compara la palabra
  return 0;
}





